Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -4263,63 +6882,121 @@
 	}
 
 	/**
-	 * [Describe function...]
+	 * Form wrap for 'Database Analyzer'
+	 * when the 'COMPARE' still contains errors
 	 *
-	 * @param	[type]		$action_type: ...
-	 * @param	[type]		$content: ...
-	 * @param	[type]		$label: ...
-	 * @return	[type]		...
+	 * @param string $action_type The action type
+	 * @param string $content The form content
+	 * @param string $label The submit button label
+	 * @return string HTML of the form
 	 */
-	function getUpdateDbFormWrap($action_type, $content, $label='Write to database')	{
-		$form = '<form action="' . $this->action . '#bottom" method="post">' .
-			'<input type="hidden" name="TYPO3_INSTALL[database_type]" value="' . htmlspecialchars($action_type) . '">' .
-				$content . '<br />' .
-			'<input type="submit" value="' . $label . '">';
+	function getUpdateDbFormWrap($action_type, $content, $label='Write to database') {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'GetUpdateDbFormWrap.html');
+			// Get the template part from the file
+		$form = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Define the markers content
+		$formMarkers = array(
+			'action' => $this->action,
+			'actionType' => htmlspecialchars($action_type),
+			'content' => $content,
+			'label' => $label
+		);
+			// Fill the markers
+		$form = $this->contentObject->substituteMarkerArray(
+			$form,
+			$formMarkers,
+			'###|###',
+			1,
+			1
+		);
+
 		return $form;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generates an HTML table for the setup of database tables
+	 * Used in 'Database analyzer > Compare with $TCA'
 	 *
-	 * @param	[type]		$arr: ...
-	 * @param	[type]		$pre: ...
-	 * @param	[type]		$label: ...
-	 * @return	[type]		...
+	 * @param array $arr Description of the table with fieldname and fieldcontent
+	 * @param boolean $pre TRUE if the field content needs to be wrapped with a <pre> tag
+	 * @param string $label The header label
+	 * @return string HTML of the table
 	 */
-	function displayFields($arr, $pre=0, $label='')	{
-		$out='';
-		$out.='<tr><td class="tcaTableHeader" align="center"><strong>'.$this->fw('Field name:').'</strong></td><td class="tcaTableHeader" align="center"><strong>'.$this->fw($label?$label:'Info:').'</strong></td></tr>';
-		if (is_array($arr))	{
-			reset($arr);
-			while(list($fieldname, $fieldContent)=each($arr))	{
-				if ($pre)	{
+	function displayFields($arr, $pre=0, $label='') {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'DisplayFields.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Define the markers content
+		$templateMarkers = array(
+			'headerFieldName' => 'Field name:',
+			'headerLabel' => $label ? $label : 'Info:'
+		);
+		if (is_array($arr)) {
+			$rows = array();
+				// Get the subpart for rows
+			$rowsSubpart = $this->contentObject->getSubpart($template, '###ROWS###');
+			foreach ($arr as $fieldname => $fieldContent) {
+				if ($pre) {
 					$fieldContent = '<pre>'.trim($fieldContent).'</pre>';
-				} else {
-					$fieldContent = $this->fw($fieldContent);
 				}
-				$out.='<tr><td class="tcaTableBackground">'.$this->fw($fieldname).'</td><td class="tcaTableBackground">'.$fieldContent.'</td></tr>';
+					// Define the markers content
+				$rowsMarkers = array(
+					'fieldName' => $fieldname,
+					'fieldContent' => $fieldContent
+				);
+					// Fill the markers in the subpart
+				$rows[] = $this->contentObject->substituteMarkerArray(
+					$rowsSubpart,
+					$rowsMarkers,
+					'###|###',
+					1,
+					1
+				);
 			}
 		}
-		$out = '<table border="0" cellpadding="0" cellspacing="1">' . $out . '</table>';
-		return $out;
+			// Substitute the subpart for rows
+		$template = $this->contentObject->substituteSubpart(
+			$template,
+			'###ROWS###',
+			implode(chr(10), $rows)
+		);
+			// Fill the markers
+		$template = $this->contentObject->substituteMarkerArray(
+			$template,
+			$templateMarkers,
+			'###|###',
+			1,
+			1
+		);
+		return $template;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generates an HTML table with comparison between database and $TCA
+	 * Used in 'Database analyzer > Compare with $TCA'
 	 *
-	 * @param	[type]		$arr: ...
-	 * @param	[type]		$arr_db: ...
-	 * @return	[type]		...
+	 * @param array $arr Description of the table with fieldname and fieldcontent
+	 * @param array $arr_db The actual content of a field in the database
+	 * @return string HTML of the table
 	 */
-	function displayFieldComp($arr, $arr_db)	{
-		$out='';
-		$out.='<tr><td bgcolor="#9BA1A8" align="center"><strong>'.$this->fw('Field name:').'</strong></td>
-			<td bgcolor="#9BA1A8" align="center"><strong>'.$this->fw("Suggested value from \$TCA:").'</strong></td>
-			<td bgcolor="#9BA1A8" align="center"><strong>'.$this->fw('Actual value from database:').'</strong></td>
-			</tr>';
-		if (is_array($arr))	{
-			reset($arr);
-			while(list($fieldname, $fieldContent)=each($arr))	{
+	function displayFieldComp($arr, $arr_db) {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'DisplayFieldComp.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Define the markers content
+		$templateMarkers = array(
+			'headerFieldName' => 'Field name:',
+			'headerSuggested' => 'Suggested value from $TCA:',
+			'headerActual' => 'Actual value from database:'
+		);
+		$rows = array();
+		if (is_array($arr)) {
+				// Get the subpart for rows
+			$rowsSubpart = $this->contentObject->getSubpart($template, '###ROWS###');
+			foreach ($arr as $fieldname => $fieldContent) {
 					// This tries to equalize the types tinyint and int
 				$str1 = $fieldContent;
 				$str2 = trim($arr_db[$fieldname]);
@@ -4328,76 +7005,151 @@
 				$str1 = str_replace('int(10)','int(11)',$str1);
 				$str2 = str_replace('int(10)','int(11)',$str2);
 					// Compare:
-				if (strcmp($str1,$str2))	{
+				if (strcmp($str1,$str2)) {
 					$bgcolor=' class="warning"';
 				} else {
-					$bgcolor=' class="generalTableBackground"';
+					$bgcolor='';
 				}
-				$fieldContent = $this->fw($fieldContent);
-				$fieldContent_db = $this->fw($arr_db[$fieldname]);
-				$out.='<tr>
-					<td class="generalTableBackground">'.$this->fw($fieldname).'</td>
-					<td'.$bgcolor.'>'.$fieldContent.'</td>
-					<td'.$bgcolor.'>'.$fieldContent_db.'</td>
-					</tr>';
+					// Define the markers content
+				$rowsMarkers = array(
+					'fieldName' => $fieldname,
+					'fieldContent' => $fieldContent,
+					'fieldContentDb' => $arr_db[$fieldname],
+					'class' => $bgcolor
+				);
+					// Fill the markers in the subpart
+				$rows[] = $this->contentObject->substituteMarkerArray(
+					$rowsSubpart,
+					$rowsMarkers,
+					'###|###',
+					1,
+					1
+				);
 			}
 		}
-		$out= '<table border="0" cellpadding="2" cellspacing="2">'.$out.'</table>';
+			// Substitute the subpart for rows
+		$template = $this->contentObject->substituteSubpart(
+			$template,
+			'###ROWS###',
+			implode(chr(10), $rows)
+		);
+			// Fill the markers
+		$out = $this->contentObject->substituteMarkerArray(
+			$template,
+			$templateMarkers,
+			'###|###',
+			1,
+			1
+		);
 		return $out;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generates an HTML table with $TCA suggestions looking at the type of field
+	 * Used in 'Database analyzer > Compare with $TCA'
 	 *
-	 * @param	[type]		$arr: ...
-	 * @param	[type]		$excludeList: ...
-	 * @return	[type]		...
+	 * @param array $arr Description of the table with fieldname and fieldcontent
+	 * @param string $excludeList Comma separated list of fields which should be excluded from this table
+	 * @return string HTML of the table
 	 */
-	function displaySuggestions($arr, $excludeList='')	{
-		$out='';
-		$out.='<tr><td bgcolor="#9BA1A8" align="center"><strong>'.$this->fw('Field name:').'</strong></td><td bgcolor="#9BA1A8" align="center"><strong>'.$this->fw('Info / Suggestion for the field:').'</strong></td></tr>';
+	function displaySuggestions($arr, $excludeList='') {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'DisplaySuggestions.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+
+		$templateMarkers = array();
 		$fC=0;
-		if (is_array($arr))	{
-			reset($arr);
-			while(list($fieldname, $fieldContent)=each($arr))	{
-				if (!t3lib_div::inList($excludeList,$fieldname) && substr($fieldname,0,strlen($this->deletedPrefixKey))!=$this->deletedPrefixKey && substr($fieldname,-1)!='.')	{
-					$fieldContent = $this->fw($fieldContent);
-					if ($arr[$fieldname.'.'])	{
-						$fieldContent.= '<hr />';
-						$fieldContent.= '<pre>'.trim($arr[$fieldname.'.']).'</pre>';
+		$rows = array();
+		if (is_array($arr)) {
+				// Get the subpart for rows
+			$rowsSubpart = $this->contentObject->getSubpart($template, '###ROWS###');
+			foreach ($arr as $fieldname => $fieldContent) {
+				if (!t3lib_div::inList($excludeList,$fieldname) && substr($fieldname,0,strlen($this->deletedPrefixKey))!=$this->deletedPrefixKey && substr($fieldname,-1)!='.') {
+					if ($arr[$fieldname.'.']) {
+							// Get the subpart for pre
+						$preSubpart = $this->contentObject->getSubpart($rowsSubpart, '###PRE###');
+							// Define the markers content
+						$preMarkers = array(
+							'code' => '<pre>' . trim($arr[$fieldname.'.']) . '</pre>'
+						);
+							// Fill the markers in the subpart
+						$preSubpart = $this->contentObject->substituteMarkerArray(
+							$preSubpart,
+							$preMarkers,
+							'###|###',
+							1,
+							1
+						);
 					}
-					$out.='<tr><td class="tcaTableBackground">'.$this->fw($fieldname).'</td><td class="tcaTableBackground">'.$fieldContent.'</td></tr>';
+						// Substitute the subpart for pre
+					$row = $this->contentObject->substituteSubpart(
+						$rowsSubpart,
+						'###PRE###',
+						$preSubpart
+					);
+						// Define the markers content
+					$rowsMarkers = array(
+						'headerFieldName' => 'Field name:',
+						'headerLabel' => 'Info:',
+						'headerSuggestion' => 'Suggestion for the field:',
+						'fieldName' => $fieldname,
+						'fieldContent' => $fieldContent,
+					);
+						// Fill the markers in the subpart
+					$rows[] = $this->contentObject->substituteMarkerArray(
+						$row,
+						$rowsMarkers,
+						'###|###',
+						1,
+						1
+					);
 					$fC++;
 				}
 			}
 		}
-		$out= '<table border="0" cellpadding="2" cellspacing="2">'.$out.'</table>';
+			// Substitute the subpart for rows
+		$template = $this->contentObject->substituteSubpart(
+			$template,
+			'###ROWS###',
+			implode(chr(10), $rows)
+		);
+			// Fill the markers
+		$out = $this->contentObject->substituteMarkerArray(
+			$template,
+			$templateMarkers,
+			'###|###',
+			1,
+			1
+		);
 		return array($out,$fC);
 	}
 
 	/**
 	 * Compares an array with field definitions with $TCA array
 	 *
-	 * @param	[type]		$FDsrc: ...
-	 * @param	[type]		$TCA: ...
-	 * @param	[type]		$onlyFields: ...
-	 * @return	[type]		...
+	 * @param array $FDsrc Field definition source
+	 * @param array $TCA The TCA array
+	 * @param boolean $onlyFields
+	 * @return array
 	 */
-	function compareDatabaseAndTCA($FDsrc, $TCA, $onlyFields=0)	{
+	function compareDatabaseAndTCA($FDsrc, $TCA, $onlyFields=0) {
 		$extraArr=array();
-		if (is_array($FDsrc))	{
-			reset($FDsrc);
-			while(list($table,$info)=each($FDsrc))	{
-				if (!isset($TCA[$table]))	{
-					if (!$onlyFields)	{
-						$extraArr[$table]=$info;		// If the table was not in the FDcomp-array, the result array is loaded with that table.
+		if (is_array($FDsrc)) {
+			foreach ($FDsrc as $table => $info) {
+				if (!isset($TCA[$table])) {
+					if (!$onlyFields) {
+							// If the table was not in the FDcomp-array, the result array is loaded with that table.
+						$extraArr[$table]=$info;
 						$extraArr[$table]['whole_table']=1;
 						unset($extraArr[$table]['keys']);
 					}
 				} else {
 					$theKey='fields';
 					$excludeListArr=array();
-					if (is_array($TCA[$table]['ctrl']['enablecolumns']))	$excludeListArr[]=$TCA[$table]['ctrl']['enablecolumns'];
+					if (is_array($TCA[$table]['ctrl']['enablecolumns'])) {
+						$excludeListArr[]=$TCA[$table]['ctrl']['enablecolumns'];
+					}
 					$excludeListArr[]=$TCA[$table]['ctrl']['tstamp'];
 					$excludeListArr[]=$TCA[$table]['ctrl']['sortby'];
 					$excludeListArr[]=$TCA[$table]['ctrl']['delete'];
@@ -4405,24 +7157,23 @@
 					$excludeListArr[]=$TCA[$table]['ctrl']['crdate'];
 					$excludeListArr[]='uid';
 					$excludeListArr[]='pid';
-					if ($table=='pages')	{
+					if ($table=='pages') {
 						$excludeListArr[]='perms_userid';
 						$excludeListArr[]='perms_groupid';
 						$excludeListArr[]='perms_user';
 						$excludeListArr[]='perms_group';
 						$excludeListArr[]='perms_everybody';
 					}
-					if ($table=='sys_dmail')	{
+					if ($table=='sys_dmail') {
 						$excludeListArr[]='scheduled';
 						$excludeListArr[]='scheduled_begin';
 						$excludeListArr[]='scheduled_end';
 						$excludeListArr[]='query_info';
 					}
 
-					if (is_array($info[$theKey]))	{
-						reset($info[$theKey]);
-						while(list($fieldN,$fieldC)=each($info[$theKey]))	{
-							if (!isset($TCA[$table]['columns'][$fieldN]) && !in_array($fieldN,$excludeListArr))	{
+					if (is_array($info[$theKey])) {
+						foreach ($info[$theKey] as $fieldN => $fieldC) {
+							if (!isset($TCA[$table]['columns'][$fieldN]) && !in_array($fieldN,$excludeListArr)) {
 								$extraArr[$table][$theKey][$fieldN] = $info['fields'][$fieldN];
 								$extraArr[$table][$theKey][$fieldN.'.']=$this->suggestTCAFieldDefinition($fieldN,$fieldC);
 							}
@@ -4437,26 +7188,23 @@
 	/**
 	 * Compares the $TCA array with a field definition array
 	 *
-	 * @param	[type]		$TCA: ...
-	 * @param	[type]		$FDcomp: ...
-	 * @return	[type]		...
+	 * @param array $TCA The TCA
+	 * @param array $FDcomp Field definition comparison
+	 * @return array
 	 */
-	function compareTCAandDatabase($TCA, $FDcomp)	{
-		$extraArr=array();
-		$matchingArr=array();
-		if (is_array($TCA))	{
-			reset($TCA);
-			while(list($table)=each($TCA))	{
-				$info=$TCA[$table];
-				if (!isset($FDcomp[$table]))	{
-//					$extraArr[$table]=$info;		// If the table was not in the FDcomp-array, the result array is loaded with that table.
+	function compareTCAandDatabase($TCA, $FDcomp) {
+		$matchingArr = $extraArr = array();
+		if (is_array($TCA)) {
+			foreach ($TCA as $table => $info) {
+				if (!isset($FDcomp[$table])) {
+						// If the table was not in the FDcomp-array, the result array is loaded with that table.
+					//$extraArr[$table]=$info;
 					$extraArr[$table]['whole_table']=1;
 				} else {
-					reset($info['columns']);
-					while(list($fieldN,$fieldC)=each($info['columns']))	{
+					foreach ($info['columns'] as $fieldN => $fieldC) {
 						$fieldDef = $this->suggestFieldDefinition($fieldC);
-						if (!is_array($fieldDef))	{
-							if (!isset($FDcomp[$table]['fields'][$fieldN]))	{
+						if (!is_array($fieldDef)) {
+							if (!isset($FDcomp[$table]['fields'][$fieldN])) {
 								$extraArr[$table]['fields'][$fieldN]=$fieldDef;
 							} else {
 								$matchingArr[$table]['fields'][$fieldN]=$fieldDef;
@@ -4472,18 +7220,18 @@
 	/**
 	 * Suggests a field definition for a TCA config array.
 	 *
-	 * @param	[type]		$fieldInfo: ...
-	 * @return	[type]		...
+	 * @param array $fieldInfo Info of a field
+	 * @return string The suggestion
 	 */
-	function suggestFieldDefinition($fieldInfo)	{
+	function suggestFieldDefinition($fieldInfo) {
 		$out='';
-		switch($fieldInfo['config']['type'])	{
+		switch($fieldInfo['config']['type']) {
 			case 'input':
-				if (preg_match('/date|time|int|year/',$fieldInfo['config']['eval']))	{
+				if (preg_match('/date|time|int|year/',$fieldInfo['config']['eval'])) {
 					$out = "int(11) NOT NULL default '0'";
 				} else {
 					$max = intval($fieldInfo['config']['max']);
-					if ($max>0 && $max<200)	{
+					if ($max>0 && $max<200) {
 						$out = 'varchar('.$max.") NOT NULL default ''";
 					} else {
 						$out = 'tinytext';
@@ -4494,42 +7242,45 @@
 				$out = 'text';
 			break;
 			case 'check':
-				if (is_array($fieldInfo['config']['items']) && count($fieldInfo['config']['items'])>8)	{
+				if (is_array($fieldInfo['config']['items']) && count($fieldInfo['config']['items'])>8) {
 					$out = "int(11) NOT NULL default '0'";
 				} else {
 					$out = "tinyint(3) NOT NULL default '0'";
 				}
 			break;
 			case 'radio':
-				if (is_array($fieldInfo['config']['items']))	{
+				if (is_array($fieldInfo['config']['items'])) {
 					$out = $this->getItemArrayType($fieldInfo['config']['items']);
 				} else {
 					$out = 'ERROR: Radiobox did not have items!';
 				}
 			break;
 			case 'group':
-				if ($fieldInfo['config']['internal_type']=='db')	{
+				if ($fieldInfo['config']['internal_type']=='db') {
 					$max = t3lib_div::intInRange($fieldInfo['config']['maxitems'],1,10000);
-					if (count(explode(',',$fieldInfo['config']['allowed']))>1)	{
-						$len = $max*(10+1+5+1);		// Tablenames are 10, "_" 1, uid's 5, comma 1
+					if (count(explode(',',$fieldInfo['config']['allowed']))>1) {
+							// Tablenames are 10, "_" 1, uid's 5, comma 1
+						$len = $max*(10+1+5+1);
 						$out=$this->getItemBlobSize($len);
 					} elseif ($max<=1) {
 						$out = "int(11) NOT NULL default '0'";
 					} else {
-						$len = $max*(5+1);		// uid's 5, comma 1
+							// uid's 5, comma 1
+						$len = $max*(5+1);
 						$out=$this->getItemBlobSize($len);
 					}
 				}
-				if ($fieldInfo['config']['internal_type']=='file')	{
+				if ($fieldInfo['config']['internal_type']=='file') {
 					$max = t3lib_div::intInRange($fieldInfo['config']['maxitems'],1,10000);
-					$len = $max*(30+1);		// Filenames is 30+ chars....
+						// Filenames is 30+ chars....
+					$len = $max*(30+1);
 					$out=$this->getItemBlobSize($len);
 				}
 			break;
 			case 'select':
 				$max = t3lib_div::intInRange($fieldInfo['config']['maxitems'],1,10000);
-				if ($max<=1)	{
-					if ($fieldInfo['config']['foreign_table'])	{
+				if ($max<=1) {
+					if ($fieldInfo['config']['foreign_table']) {
 						$out = "int(11) NOT NULL default '0'";
 					} else {
 						$out = $this->getItemArrayType($fieldInfo['config']['items']);
@@ -4547,25 +7298,24 @@
 	}
 
 	/**
+	 * Check if field needs to be varchar or int
 	 * Private
 	 *
-	 * @param	[type]		$arr: ...
-	 * @return	[type]		...
+	 * @param array $arr
+	 * @return string The definition
 	 */
-	function getItemArrayType($arr)	{
-		if (is_array($arr))	{
-			reset($arr);
-			$type[]=0;
-			$intSize[]=0;
-			while(list(,$item)=each($arr))	{
-				if (!t3lib_div::testInt($item[1]) && $item[1]!='--div--')	{
+	function getItemArrayType($arr) {
+		if (is_array($arr)) {
+			$type[] = $intSize[] = 0;
+			foreach ($arr as $item) {
+				if (!t3lib_div::testInt($item[1]) && $item[1]!='--div--') {
 					$type[]=strlen($item[1]);
 				} else {
 					$intSize[]=$item[1];
 				}
 			}
 			$us = min($intSize)>=0 ? ' unsigned' : '';
-			if (max($type)>0)	{
+			if (max($type)>0) {
 				$out = 'varchar('.max($type).") NOT NULL default ''";
 			} else {
 				$out = "int(11) NOT NULL default '0'";
@@ -4575,25 +7325,26 @@
 	}
 
 	/**
+	 * Defines the blob size of an item by a given length
 	 * Private
 	 *
-	 * @param	[type]		$len: ...
-	 * @return	[type]		...
+	 * @param integer $len The length
+	 * @return string The blob definition
 	 */
-	function getItemBlobSize($len)	{
+	function getItemBlobSize($len) {
 		return ($len>255 ? 'tiny' : '').'blob';
 	}
 
 	/**
 	 * Should suggest a TCA configuration for a specific field.
 	 *
-	 * @param	[type]		$fieldName: ...
-	 * @param	[type]		$fieldInfo: ...
-	 * @return	[type]		...
+	 * @param string $fieldName The field name
+	 * @param string $fieldInfo The field information
+	 * @return string Suggested TCA configuration
 	 */
-	function suggestTCAFieldDefinition($fieldName,$fieldInfo)	{
+	function suggestTCAFieldDefinition($fieldName,$fieldInfo) {
 		list($type,$len) = preg_split('/ |\(|\)/', $fieldInfo, 3);
-		switch($type)	{
+		switch($type) {
 			case 'int':
 $out="
 '".$fieldName."' => array (
@@ -4626,7 +7377,7 @@
 ),";
 			break;
 			case 'varchar':
-				if ($len>10)	{
+				if ($len>10) {
 					$out="
 '".$fieldName."' => array (
 	'label' => '".strtoupper($fieldName).":',
@@ -4732,26 +7483,25 @@
 	/**
 	 * Includes TCA
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function includeTCA()	{
+	function includeTCA() {
 		global $TCA;
 
 		include (TYPO3_tables_script ? PATH_typo3conf.TYPO3_tables_script : PATH_t3lib.'stddb/tables.php');
 
 			// Extension additions
-		if ($GLOBALS['TYPO3_LOADED_EXT']['_CACHEFILE'])	{
+		if ($GLOBALS['TYPO3_LOADED_EXT']['_CACHEFILE']) {
 			include(PATH_typo3conf.$GLOBALS['TYPO3_LOADED_EXT']['_CACHEFILE'].'_ext_tables.php');
 		} else {
 			include(PATH_t3lib.'stddb/load_ext_tables.php');
 		}
 
-		if (TYPO3_extTableDef_script)	{
+		if (TYPO3_extTableDef_script) {
 			include (PATH_typo3conf.TYPO3_extTableDef_script);
 		}
 
-		reset($TCA);
-		while(list($table)=each($TCA))	{
+		foreach ($TCA as $table => $conf) {
 			t3lib_div::loadTCA($table);
 		}
 	}
